; Copyright AuthenTec 2000
; Version 1.0.0
; PIC12C508  Software for power cycling
;
        TITLE "AuthenTec Proprietary"
        LIST  P=12C508A, C=132, N=60
;*****************************************************************************
        INCLUDE "p12c508a.inc"
REG7	EQU	7
REG8	EQU	8
;Fuse Settings

page
      org     0         ; PIC starts at 0 upon reset

init	movlw	20h		; prepare to turn AES4000 off
	movwf	GPIO		; bit is set high but still tri-stated
	movlw	1Fh		; only output is GPIO5
	tris	GPIO		; now AES4000 is off
				; use 1F in W for option
	option	      ; Wake-up on pin change is enabled
				; GP0, GP1, and GP3 weak pull-ups are enabled
				; Timer0 clock source internal OSC/4
				; Timer0 inc on high to low transition
				; Prescaler assigned to WDT
				; Prescaler is maxed at 1:128
fault	bsf	GPIO,5	; turn AES4000 off				OFF
	btfss	GPIO,0	; wait here until fault goes away.		OFF
	goto	fault		;          						OFF

	clrf	REG7		; clear counter lsb				OFF
	clrf	REG8		; clear counter msb				OFF
	decfsz	REG7	; inner loop delay 				OFF
	goto	$-1		;							OFF
	decfsz	REG8	; outer loop delay				OFF
	goto	$-3		;  total delay about 66mS			OFF

	bcf	GPIO,5	; turn on AES4000					ON

	clrf	REG7		; clear counter lsb				ON 
	clrf	REG8		; clear counter msb				ON
	decfsz	REG7	; inner loop delay 				ON
	goto	$-1		;							ON
	decfsz	REG8	; outer loop delay				ON
	goto	$-3		;  total delay about 66mS			ON

	btfss	GPIO,0	; if fault is active				ON
	goto	fault		; loop back again					ON

	sleep			; else sleep until fault happens		MONITOR
	goto	fault		;
end
